# $Progeny: common.py,v 1.36 2002/06/06 21:47:44 branden Exp $

import os
import re
import select
import sys
from popen2 import Popen3

# fucking python...
TRUE = 1
FALSE = 0

# Unfortunately Python has no sysexits.h equivalent, so this is
# correct for GNU libc 2.2.4 but may not always be so.
EX_OK=		0
EX__BASE=	64
EX_USAGE=	64
EX_DATAERR=	65
EX_NOINPUT=	66
EX_NOUSER=	67
EX_NOHOST=	68
EX_UNAVAILABLE=	69
EX_SOFTWARE=	70
EX_OSERR=	71
EX_OSFILE=	72
EX_CANTCREAT=	73
EX_IOERR=	74
EX_TEMPFAIL=	75
EX_PROTOCOL=	76
EX_NOPERM=	77
EX_CONFIG=	78
EX__MAX = 78

EX_USERCANCEL = EX__MAX + 12

# Decent base partition sizes
ROOT_MB = 800
SWAP_MB = 128
EFIBOOT_MB = 64

# Fake gettext; might be interested in i18n one day.
def _(s):
    return s

def msg(s):
    log = open(get_logfile(), "a")

    log.write("%s: %s" % (sys.argv[0], s))

    log.close()

def warn(s):
    msg("WARNING: %s" % (s,))

def get_live():
    if os.getenv("LIVE"):
        return os.getenv("LIVE")

    return "/live"

def get_logfile():
    if os.getenv("LOGFILE"):
        return os.getenv("LOGFILE")

    return "/var/log/installer.log"

def get_target():
    if os.getenv("TARGET"):
        return os.getenv("TARGET")

    return "/target"

def crunchline(line=None, max_line_length=80):
    # debootstrap has output like this:
    #I: Retrieving http://archive.progeny.com/debian/dists/woody/Release
    #I: Retrieving http://archive.progeny.com/debian/dists/woody/main/binary-i386/Packages.gz
    #I: Retrieving http://archive.progeny.com/debian/pool/main/b/base-passwd/base-passwd_3.2.1_i386.deb
    #...
    #I: Extracting /var/cache/apt/archives/sysvinit_2.83-2_i386.deb...
    if line:
        if (re.match("^I: .*", line)):
            # strip off the leading "I: "
            line = re.sub(r'^I: ', '', line)

        # strip off any trailing newlines
        while (len(line) > 0) and (line[-1] == "\n"):
            # import chomp ;-)
            line = line[0:-1]

        # is the line too long?
        if len(line) > max_line_length:
            # see if there's a long path we can shorten
            if re.match(r'\s', line):
                (words, lastword) = re.split(r'\s', line, 1)
                line = re.sub(re.escape(lastword), os.path.basename(lastword), line)
        # still too long?
        if len(line) > max_line_length:
            # take the excess out of the middle
            center = len(line) / 2
            excess = abs(max_line_length - len(line))
            line = line[:(center - (excess / 2) - 2)] + "..." + line[(center + (excess / 2) + 2):]

        return line

def run_command(command, tries=1, callback=None, cbdata=None):
    # NOTE: run_command's return value is an *exit status*.  That means 0 is
    # success and any other value is failure.

    result = None

    while (tries > 0):
        msg("Running command \"%s\".\n" % (command,))

        # Set up a pipe object for the command to be run.
        # XXX: stupid.  Why not have a Popen2() class for the people who don't
        # want stderr?
        commandpipe = Popen3(command, TRUE)

        # We are interested in the standard output and standard error streams
        # from our command.
        (command_stdout, command_stderr) = (commandpipe.fromchild, commandpipe.childerr)

        # Set up a list containing the streams of interest for select().
        readfds = [ command_stdout, command_stderr ]
        try:
            # Wait on our streams to return data, or for our command to exit.
            # XXX: jerkoffs will take integers and empty lists but not None
            (readfds, discard, discard) = select.select(readfds, [], [])

            # Loop forever until our command dies.
            while TRUE:
                outline = None
                errline = None

                # Data on standard output?
                if command_stdout in readfds:
                    outline = command_stdout.readline()

                # Data on standard error?
                if command_stderr in readfds:
                    errline = command_stderr.readline()

                # Lines of output on either stream?
                if outline or errline:
                    if outline:
                        # Log the command's output.
                        msg(outline)
                        if callback:
                            # Parent function also wants the data.
                            callback(outline, cbdata)
                        else:
                            # Display the command's output.
                            sys.stdout.write(outline)
                            sys.stdout.flush()

                    if errline:
                        # Log the command's errors.
                        msg("stderr: %s" % (errline,))

                else:
                    # Nothing on standard output or standard error; our command
                    # has died.
                    break

                # Again, wait on our streams to return data, or for our command
                # to exit.  We only do this again because Python doesn't have
                # do-while.
                readfds = [ command_stdout, command_stderr ]
                # XXX: jerkoffs redux: will take integers and empty lists but not None
                (readfds, discard, discard) = select.select(readfds, [], [])

        except select.error, what:
            # Handle exceptions, presumably from select().
            (errno, strerror) = what
            warn("select() failed (errno %d): %s\n" % (errno, strerror))
            return FALSE

        result = os.WEXITSTATUS(commandpipe.wait())

        tries = tries - 1

        msg("Command \"%s\" exited with status %d.\n" % (command, result))

    return result

if __name__ == "__main__":
    pass

# vim:ai:et:sts=4:sw=4:tw=0:
