#! /usr/bin/python

# $Progeny: setup-bootloader-text.py,v 1.11 2002/06/12 19:45:36 branden Exp $

import sys

import pgi.bootloader
import pgi.common

from getopt import getopt, GetoptError
from pgi.common import TRUE, FALSE, EX_USAGE, _, warn

def print_statusline(line, msgtype = None):
    if line:
        # don't let message lines get too long
        line = pgi.common.crunchline(line, 70)
        sys.stdout.write("%s\n" % (line,))
        sys.stdout.flush()

###############################################################################
# getopt

device = None
root = None
target = "/target"

try:
    (opts, args) = getopt(sys.argv[1:], "",
                          ["root=", "target="])
except GetoptError:
    sys.exit(EX_USAGE)

for (o, a) in opts:
    if o == "--root":
        root = a
    elif o == "--target":
        target = a

if not root:
    sys.exit(EX_USAGE)

if len(args) == 0:
    sys.exit(EX_USAGE)

device = args[0]

###############################################################################
# Main

print "Installing boot loader to %s..." % (device,)
pgi.bootloader.install(device, root, target, print_statusline)

# vim:ai:et:sts=4:sw=4:tw=0:
